
import java.io.IOException;
import java.io.PrintStream;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.Set;
import javax.xml.namespace.QName;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPConnection;
import javax.xml.soap.SOAPConnectionFactory;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPMessage;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
/*
 * JvtSessionWsClient.java
 *
 * Created on June 12, 2007, 9:57 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */



/**
 *
 * @author vince
 */
public class JvtSessionWsClient {
    
    private String endpointUrl = null;
    
    // change this to redirect output if desired
    private static PrintStream out = System.out;
    
    public JvtSessionWsClient(String url){
        setEndpointUrl(url);
    }
    
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
       JvtSessionWsClient test = new JvtSessionWsClient("http://localhost:8080/JVTSessionWebService/JVTSessionWebService");
        String request = new String();
        //request += "<getEventTypesRequest xmlns=\"http://ossj.org/xml/Common/v1-5\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:nil=\"true\"/>";
        //request += "<getManagedEntityTypesRequest xmlns=\"http://ossj.org/xml/Common/v1-5\"/>";
        
        //request += "<getEventDescriptorRequest xmlns=\"http://ossj.org/xml/Common/v1-5\">";
        //request += "<eventType>ossj.common.ex.MplsVpnCreateEventImpl</eventType>";
        //request += "</getEventDescriptorRequest>";
        
        request += "<co-v1-5:getEventDescriptorRequest xmlns:co-v1-5=\"http://ossj.org/xml/Common/v1-5\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://ossj.org/xml/Common/v1-5 ../src/main/xsd/xml/Common/v1-5/OSSJ-Common-v1-5.xsd \">";
        request += "<co-v1-5:eventType>ossj.common.ex.MplsVpnCreateEventImpl</co-v1-5:eventType>";
        request += "</co-v1-5:getEventDescriptorRequest>";
        
        try {
            System.out.println("Response is:\n"+test.processRequest(request));
            
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    
    public String processRequest(final String request) throws Exception {
        
        SOAPMessage soapReq = getSOAPRequest(request);
        SOAPConnectionFactory factory = SOAPConnectionFactory.newInstance();
        SOAPConnection soapCon = factory.createConnection();
        
        SOAPMessage soapResp = soapCon.call(soapReq, endpointUrl);
        
        SOAPBody respBody = soapResp.getSOAPBody();
        
        DOMSource domSource;
        if (respBody.hasFault()) {
            domSource = new DOMSource(soapResp.getSOAPBody().getFault());
        } else {
            domSource = new DOMSource(soapResp.getSOAPBody().getFirstChild());
        }
        StringWriter sw = new StringWriter();
        StreamResult streamResult = new StreamResult(sw);
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer serializer = tf.newTransformer();
        serializer.setOutputProperty(OutputKeys.INDENT, "yes");
        serializer.transform(domSource, streamResult);
        
        return sw.toString();
    }
    
    /**
     * Constructs a SOAPRequest containing the specified payload.
     * @param payload The payload to be included in the SOAPRequest.
     * @return Constructed SOAP message.
     * @throws SOAPException
     * @throws ParserConfigurationException
     * @throws SAXException
     * @throws IOException
     */
    protected SOAPMessage getSOAPRequest(final String payload)
    throws SOAPException, ParserConfigurationException, SAXException,
            IOException {
        
        MessageFactory mf = MessageFactory.newInstance();
        SOAPMessage soapMsg = mf.createMessage();
        
        SOAPBody soapBody = soapMsg.getSOAPBody();
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setNamespaceAware(true);
        DocumentBuilder builder = factory.newDocumentBuilder();
        
        Document document = builder.parse(
                new InputSource(new StringReader(payload)));
        
        soapBody.addDocument(document);
        System.out.println("The Document:\n");
        soapMsg.writeTo(System.out);
        
        return soapMsg;
    }
    
    /**
     * Sets the endpointUrl.
     * @param epUrl The endpoint URL.
     */
    public void setEndpointUrl(final String epUrl) {
        //http://localhost:8080/JVTSessionWebService/JVTSessionWebService
        endpointUrl = epUrl;
    }
}
