/*
Copyright 2002-2005 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
*/
package javax.oss;


/**
 * Similar to java.lang.IllegalStateException,
 * except this inherits from Exception, not RuntimeException.
 * This new class is required because J2EE containers deal with
 * RuntimeException in a special way.  See EJB specification.
 * <p>
 * The IllegalStateException  exception is thrown by a JVT Session Bean
 * to report that the invoked business method could not be completed because
 * the operation was invoked at an illegal or inappropriate time.
 * <p>
 * Note: This exception replaces the deprecated javax.oss.IllegalStateException
 * 
 * @author OSS through Java Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.2
 * @since August 2005
 * @ossj:exception
 */
//AB decision 2005-08-12: Use OSS prefix for all OSSJ exception and respect the Exception inheritence
public class OssIllegalStateException extends Exception {
//public class OssIllegalStateException extends IllegalStateException {
    /**
     * Constructs an OssIllegalStateException with no detail message.
     */
    public OssIllegalStateException() {
        super();
    }

    /**
     * Constructs an OssIllegalStateException with the specified detail message.
     *
     *@param message The detail message.
     */
    public OssIllegalStateException(String message) {
        super(message);
    }
}
