/*
Copyright 2002-2006 The Members of the OSS through Java(TM) Initiative.
All rights reserved. Use is subject to license terms.
 */
package ossj.common.ex;



/**
 * An implementation class for the <CODE>ossj.common.ex.MplsVpnCreateEventPropertyDescriptor</CODE> interface.
 *
 * @see ossj.common.ex.MplsVpnCreateEventPropertyDescriptor
 *
 * @author OSS through Java(tm) Initiative, Vincent Perrot Sun Microsystems Inc.
 * @version 1.3
 * @since January 2006
 */


public class MplsVpnCreateEventPropertyDescriptorImpl
        extends ossj.common.EventPropertyDescriptorImpl
        implements MplsVpnCreateEventPropertyDescriptor {
    
    /**
     * Constructs a new MplsVpnCreateEventPropertyDescriptorImpl with empty attributes.
     *
     */
    
    public MplsVpnCreateEventPropertyDescriptorImpl() {
        super(MplsVpnCreateEventImpl.class.getName(),
                new String[] {
            MplsVpnCreateEventPropertyDescriptor.OSS_APPLICATION_DN_PROP_NAME ,MplsVpnCreateEventPropertyDescriptor.OSS_EVENT_TYPE_PROP_NAME ,MplsVpnCreateEventPropertyDescriptor.MPLS_VPN_SERVICE_VRF_NAME_PROP_NAME },
                new String[] {
            MplsVpnCreateEventPropertyDescriptor.OSS_APPLICATION_DN_PROP_TYPE ,MplsVpnCreateEventPropertyDescriptor.OSS_EVENT_TYPE_PROP_TYPE ,MplsVpnCreateEventPropertyDescriptor.MPLS_VPN_SERVICE_VRF_NAME_PROP_TYPE },
                new MplsVpnCreateEventImpl());
    }
    
    /**
     * Constructs a new MplsVpnCreateEventPropertyDescriptorImpl using the given attributes.
     *
     */
    public MplsVpnCreateEventPropertyDescriptorImpl(String type, String[] propertyNames,
            String[] propertyTypes, javax.oss.Event dummyEvent)
            throws IllegalArgumentException {
        super(type, propertyNames, propertyTypes, dummyEvent);
    }
    
    
    //==================================================================
    // FACTORIES AND ATTRIBUTE TYPE FOR ================================
    //==================================================================
    
    public ossj.common.ex.MplsVpnCreateEvent makeMplsVpnCreateEvent(String type){
        return new MplsVpnCreateEventImpl();
    }
}