
package org.ossj.xml.common.v1_5;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;


/**
 * The ApplicationContext interface contains the URL and
 *                 other system properties required to set up an initial
 *                 connection with the JNDI provider into which the
 *                 components in charge of that managed entity are registered.
 *                 <p>
 *                 Security Credentials are not passed.
 *             <p>
 * 
 * <p>Java class for ApplicationContext complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="ApplicationContext">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="factoryClass" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="URL" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="systemProperties" type="{http://ossj.org/xml/Common/v1-5}ArrayOfSystemProperties"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ApplicationContext", propOrder = {
    "factoryClass",
    "url",
    "systemProperties"
})
public class ApplicationContext {

    @XmlElement(required = true)
    protected String factoryClass;
    @XmlElement(name = "URL", required = true)
    protected String url;
    @XmlElement(required = true)
    protected ArrayOfSystemProperties systemProperties;

    /**
     * Gets the value of the factoryClass property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getFactoryClass() {
        return factoryClass;
    }

    /**
     * Sets the value of the factoryClass property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setFactoryClass(String value) {
        this.factoryClass = value;
    }

    /**
     * Gets the value of the url property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getURL() {
        return url;
    }

    /**
     * Sets the value of the url property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setURL(String value) {
        this.url = value;
    }

    /**
     * Gets the value of the systemProperties property.
     * 
     * @return
     *     possible object is
     *     {@link ArrayOfSystemProperties }
     *     
     */
    public ArrayOfSystemProperties getSystemProperties() {
        return systemProperties;
    }

    /**
     * Sets the value of the systemProperties property.
     * 
     * @param value
     *     allowed object is
     *     {@link ArrayOfSystemProperties }
     *     
     */
    public void setSystemProperties(ArrayOfSystemProperties value) {
        this.systemProperties = value;
    }

}
