
package org.ossj.xml.common.v1_5;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;


/**
 * The EventPropertyDescriptor is used to document and
 *                 specify the filterable properties of an event.
 *                 <p>
 *                 An Interface extending the base EventPropertyDescriptor
 *                 interface must be defined for each type of application
 *                 specific event emitted by a component.
 *                 <p>
 *                 The name of the specific EventPropertyDescriptor
 *                 interface should be <i>EventType</i>EventPropertyDescriptor
 *                 where the <i>EventType</i> is the name of the event type
 *                 interface.
 *                 <p>
 *                 Example:<br>
 *                 <UL>
 *                 <LI>NotifyAckStateChangedEvent
 *                 <LI>NotifyAckStateChangedEventEventPropertyDescriptor
 *             </UL>
 * 
 * <p>Java class for EventPropertyDescriptor complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="EventPropertyDescriptor">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="eventType" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *         &lt;element name="propertyNames" type="{http://ossj.org/xml/Common/v1-5}ArrayOfString"/>
 *         &lt;element name="propertyTypes" type="{http://ossj.org/xml/Common/v1-5}ArrayOfString"/>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "EventPropertyDescriptor", propOrder = {
    "eventType",
    "propertyNames",
    "propertyTypes"
})
public abstract class EventPropertyDescriptor {

    @XmlElement(required = true)
    protected String eventType;
    @XmlElement(required = true)
    protected ArrayOfString propertyNames;
    @XmlElement(required = true)
    protected ArrayOfString propertyTypes;

    /**
     * Gets the value of the eventType property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getEventType() {
        return eventType;
    }

    /**
     * Sets the value of the eventType property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setEventType(String value) {
        this.eventType = value;
    }

    /**
     * Gets the value of the propertyNames property.
     * 
     * @return
     *     possible object is
     *     {@link ArrayOfString }
     *     
     */
    public ArrayOfString getPropertyNames() {
        return propertyNames;
    }

    /**
     * Sets the value of the propertyNames property.
     * 
     * @param value
     *     allowed object is
     *     {@link ArrayOfString }
     *     
     */
    public void setPropertyNames(ArrayOfString value) {
        this.propertyNames = value;
    }

    /**
     * Gets the value of the propertyTypes property.
     * 
     * @return
     *     possible object is
     *     {@link ArrayOfString }
     *     
     */
    public ArrayOfString getPropertyTypes() {
        return propertyTypes;
    }

    /**
     * Sets the value of the propertyTypes property.
     * 
     * @param value
     *     allowed object is
     *     {@link ArrayOfString }
     *     
     */
    public void setPropertyTypes(ArrayOfString value) {
        this.propertyTypes = value;
    }

}
