
package org.ossj.xml.common.v1_5;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;


/**
 * Similar to javax.oss.OssIllegalArgumentException,
 *                 except it specifically refers to a bad value associated
 *                 with an attribute name within an AttributeAccess object.
 *                 
 *                 This exception is thrown if an AttributeAccess object passed
 *                 to a remote method contains an attribute with a bad value.
 *                 
 *                 <p>
 *             Note: This exception replaces the deprecated javax.oss.IllegalAttributeValueException
 * 
 * <p>Java class for OssIllegalAttributeValueException complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="OssIllegalAttributeValueException">
 *   &lt;complexContent>
 *     &lt;extension base="{http://ossj.org/xml/Common/v1-5}OssIllegalArgumentException">
 *       &lt;sequence>
 *         &lt;element name="illegalAttributeName" type="{http://www.w3.org/2001/XMLSchema}string"/>
 *       &lt;/sequence>
 *     &lt;/extension>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "OssIllegalAttributeValueException", propOrder = {
    "illegalAttributeName"
})
public class OssIllegalAttributeValueException
    extends OssIllegalArgumentException
{

    @XmlElement(required = true)
    protected String illegalAttributeName;

    /**
     * Gets the value of the illegalAttributeName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getIllegalAttributeName() {
        return illegalAttributeName;
    }

    /**
     * Sets the value of the illegalAttributeName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setIllegalAttributeName(String value) {
        this.illegalAttributeName = value;
    }

}
