
package org.ossj.xml.common.v1_5;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlType;


/**
 * Similar to java.lang.IllegalStateException,
 *                 except this inherits from Exception, not RuntimeException.
 *                 This new class is required because J2EE containers deal with
 *                 RuntimeException in a special way.  See EJB specification.
 *                 <p>
 *                 The IllegalStateException  exception is thrown by a JVT Session Bean
 *                 to report that the invoked business method could not be completed because
 *                 the operation was invoked at an illegal or inappropriate time.
 *                 <p>
 *             Note: This exception replaces the deprecated javax.oss.IllegalStateException
 * 
 * <p>Java class for OssIllegalStateException complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="OssIllegalStateException">
 *   &lt;complexContent>
 *     &lt;extension base="{http://ossj.org/xml/Common/v1-5}BaseException">
 *       &lt;sequence>
 *       &lt;/sequence>
 *     &lt;/extension>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "OssIllegalStateException")
public class OssIllegalStateException
    extends BaseException
{


}
